<template lang="pug">
.chat-component
  .messages-container
    .message(v-for="msg in messages")
      .left
        img(src="https://openclipart.org/download/247316/abstract-user-flat-2.svg")
      .right
        span.name {{ msg.user }}
        span.date {{ moment(msg.date).format('ddd, h:m A') }}
        .msg: p {{ msg.message }}
  .new-message-container
    input(@keyup.enter='sendMessage' v-model='newMessage')
</template>

<script>
import moment from 'moment'

export default {
  name: 'chat-component',
  data () {
    return {
      user: this.$store.state.user,
      newMessage: '',
      moment
    }
  },
  computed: {
    messages () {
      return this.$store.state.messages.filter((i) => i.group === this.$store.state.currentGroup)
    }
  },
  methods: {
    sendMessage () {
      let message = {
        message: this.newMessage,
        date: Date.now(),
        user: this.$store.state.user.username,
        group: this.$store.state.currentGroup
      }
      this.$socket.send(message)
      this.newMessage = ''
    }
  },

  mounted () {
    this.chatElement = document.querySelector('.messages-container')
  },

  updated () {
    // TODO: Improve the query element
    this.chatElement.scrollTop = this.chatElement.scrollHeight
  }

}
</script>
